%define anolis_release 1
%global with_broadway 1
%global bin_version 3.0.0

%global __provides_exclude_from ^%{_libdir}/gtk-3.0

Name:    gtk3
Version: 3.24.43
Release: %{anolis_release}%{?dist}
Summary: GTK+ graphical user interface library

License: LGPL-2.0-or-later
URL:     https://gtk.org
Source0: https://download.gnome.org/sources/gtk+/3.24/gtk+-%{version}.tar.xz
Patch0: 1001-fix-build-failed-with-array-bound.patch

BuildRequires: desktop-file-utils, gettext, gtk-doc, meson, cmake > 3.3.0
BuildRequires: cups-devel

BuildRequires: pkgconfig(atk) >= 2.35.1
BuildRequires: pkgconfig(atk-bridge-2.0)
BuildRequires: pkgconfig(avahi-gobject)
BuildRequires: pkgconfig(cairo) >= 1.14.0
BuildRequires: pkgconfig(cairo-gobject) >= 1.14.0
BuildRequires: pkgconfig(gdk-pixbuf-2.0) >= 2.30.0
BuildRequires: pkgconfig(glib-2.0) >= 2.57.2
BuildRequires: pkgconfig(gobject-introspection-1.0)
BuildRequires: pkgconfig(pango) >= 1.41.0
BuildRequires: pkgconfig(xi)
BuildRequires: pkgconfig(xrandr) >= 1.5.0
BuildRequires: pkgconfig(xrender)
BuildRequires: pkgconfig(xcursor)
BuildRequires: pkgconfig(xfixes)
BuildRequires: pkgconfig(xinerama)
BuildRequires: pkgconfig(xcomposite)
BuildRequires: pkgconfig(xdamage)
BuildRequires: pkgconfig(xkbcommon)
BuildRequires: pkgconfig(egl)
BuildRequires: pkgconfig(colord)
BuildRequires: pkgconfig(tracker-sparql-3.0)
BuildRequires: pkgconfig(wayland-client) >= 1.14.91
BuildRequires: pkgconfig(wayland-cursor) >= 1.14.91
BuildRequires: pkgconfig(wayland-egl) >= 1.14.91
BuildRequires: pkgconfig(wayland-protocols) >= 1.17
BuildRequires: pkgconfig(cloudproviders)
BuildRequires: pkgconfig(epoxy)

Requires: adwaita-icon-theme, hicolor-icon-theme, gtk-update-icon-cache
Requires: atk >= 2.35.1
Requires: cairo >= 1.14.0
Requires: cairo-gobject >= 1.14.0
Requires: glib2 >= 2.57.2
Requires: libepoxy >= 1.4
Requires: libwayland-client >= 1.14.91
Requires: libwayland-cursor >= 1.14.91
Requires: libXrandr >= 1.5.0
Requires: pango >= 1.41.0
Requires: gdk-pixbuf2-modules

Recommends: dconf
Recommends: libcanberra-gtk3
Recommends: tracker-miners

%description
GTK is a widget toolkit. Each user interface created by GTK consists of UI elements
known as widgets. The GTK programming interface is based on Object Orientation;
widgets are organized in a hierarchy of classes—for instance, the window widget
is also a specialised container, called a “bin”, that can hold at most one child
widget. A window will be able to use functions that pertain to the widget, container,
bin, and window classes. Each user interface is built by adding buttons, text labels,
input fields, drop down menus, and other widgets to a window.

This package contains version 3 of GTK+.

%package devel
Summary: Development files for GTK+
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the libraries and header files that are needed
for writing applications with version 3 of the GTK+ widget toolkit. If
you plan to develop applications with GTK+, consider installing the
gtk3-devel-docs package.

%package devel-docs
Summary: Developer documentation for GTK+
Requires: %{name} = %{version}-%{release}

%description devel-docs
This package contains developer documentation for version 3 of the GTK+
widget toolkit.

%package -n gtk-update-icon-cache
Summary: Icon theme caching utility

%description -n gtk-update-icon-cache
GTK+ can use the cache files created by gtk-update-icon-cache to avoid a lot of
system call and disk seek overhead when the application starts. Since the
format of the cache files allows them to be mmap()ed shared between multiple
applications, the overall memory consumption is reduced as well.

%package immodules
Summary: Input methods for GTK+
Requires: %{name} = %{version}-%{release}
Requires: gtk2-immodules

%description immodules
The gtk3-immodules package contains standalone input methods that
are shipped as part of GTK+ 3.

%package immodule-xim
Summary: XIM support for GTK+
Requires: %{name} = %{version}-%{release}

%description immodule-xim
The gtk3-immodule-xim package contains XIM support for GTK+ 3.

%package tests
Summary: Tests for the %{name} package
Requires: %{name} = %{version}-%{release}

%description tests
The %{name}-tests package contains tests that can be used to verify
the functionality of the installed %{name} package.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n gtk+-%{version} -p1

%build
export CFLAGS='-fno-strict-aliasing %optflags'
%meson \
%if 0%{?with_broadway}
        -Dbroadway_backend=true \
%endif
        -Dbuiltin_immodules=wayland,waylandgtk \
        -Dcolord=yes \
        -Dcloudproviders=true \
        -Dgtk_doc=true \
        -Dinstalled_tests=true \
        -Dman=true \
        -Dprofiler=true \
        -Dtracker3=true \
        -Dxinerama=yes \
%meson_build

%install
%meson_install

%find_lang gtk30
%find_lang gtk30-properties

(cd %{buildroot}/%{_bindir}
 mv gtk-query-immodules-3.0 gtk-query-immodules-3.0-%{__isa_bits}
)

echo ".so man1/gtk-query-immodules-3.0.1" > %{buildroot}/%{_mandir}/man1/gtk-query-immodules-3.0-%{__isa_bits}.1

%if !0%{?with_broadway}
rm %{buildroot}/%{_mandir}/man1/broadwayd.1*
%endif

touch %{buildroot}/%{_libdir}/gtk-3.0/%{bin_version}/immodules.cache

mkdir -p %{buildroot}/%{_sysconfdir}/gtk-3.0
mkdir -p %{buildroot}/%{_libdir}/gtk-3.0/modules
mkdir -p %{buildroot}/%{_libdir}/gtk-3.0/immodules

%generate_compatibility_deps

%transfiletriggerin -- %{_libdir}/gtk-3.0/3.0.0/immodules
gtk-query-immodules-3.0-%{__isa_bits} --update-cache &>/dev/null || :

%transfiletriggerpostun -- %{_libdir}/gtk-3.0/3.0.0/immodules
gtk-query-immodules-3.0-%{__isa_bits} --update-cache &>/dev/null || :

%files -f gtk30.lang
%dir %{abidir}
%license COPYING
%{_bindir}/gtk-query-immodules-3.0*
%{_bindir}/gtk-launch
%{_libdir}/libgtk-3.so.*
%{_libdir}/libgdk-3.so.*
%{_libdir}/libgailutil-3.so.*
%{abidir}/libgtk-3.dump
%{abidir}/libgdk-3.dump
%{abidir}/libgailutil-3.dump
%{abidir}/gtk-launch-option.list
%{abidir}/libprintbackend-cups.dump
%{abidir}/libprintbackend-file.dump
%{abidir}/libprintbackend-lpr.dump
%dir %{_libdir}/gtk-3.0
%dir %{_libdir}/gtk-3.0/%{bin_version}
%dir %{_libdir}/gtk-3.0/%{bin_version}/immodules
%{_libdir}/gtk-3.0/%{bin_version}/printbackends
%{_libdir}/gtk-3.0/modules
%{_libdir}/gtk-3.0/immodules
%{_datadir}/themes/Default
%{_datadir}/themes/Emacs
%{_libdir}/girepository-1.0
%ghost %{_libdir}/gtk-3.0/%{bin_version}/immodules.cache
%{_mandir}/man1/gtk-query-immodules-3.0*
%{_mandir}/man1/gtk-launch.1*
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.ColorChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.Debug.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.EmojiChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.exampleapp.gschema.xml
%dir %{_datadir}/gtk-3.0
%{_datadir}/gtk-3.0/emoji/
%if 0%{?with_broadway}
%{_bindir}/broadwayd
%{abidir}/broadwayd-option.list
%{_mandir}/man1/broadwayd.1*
%endif

%files devel -f gtk30-properties.lang
%{_libdir}/lib*.so
%{_includedir}/*
%{_datadir}/aclocal/*
%{_libdir}/pkgconfig/*
%{_datadir}/aclocal/gtk-3.0.m4
%{_libdir}/pkgconfig/g*-3.0.pc
%{_bindir}/gtk3-demo
%{_bindir}/gtk3-icon-browser
%{_bindir}/gtk-builder-tool
%{_bindir}/gtk-encode-symbolic-svg
%{_bindir}/gtk-query-settings
%{_datadir}/applications/gtk3-demo.desktop
%{_datadir}/applications/gtk3-icon-browser.desktop
%{_datadir}/applications/gtk3-widget-factory.desktop
%{_datadir}/icons/hicolor/*/apps/gtk3-demo.png
%{_datadir}/icons/hicolor/*/apps/gtk3-demo-symbolic.symbolic.png
%{_datadir}/icons/hicolor/*/apps/gtk3-widget-factory.png
%{_datadir}/icons/hicolor/*/apps/gtk3-widget-factory-symbolic.symbolic.png
%{_bindir}/gtk3-demo-application
%{_bindir}/gtk3-widget-factory
%{abidir}/gtk3-demo-option.list
%{abidir}/gtk3-icon-browser-option.list
%{abidir}/gtk-encode-symbolic-svg-option.list
%{abidir}/gtk3-widget-factory-option.list
%{_datadir}/gettext/
%{_datadir}/gir-1.0
%{_datadir}/glib-2.0/schemas/org.gtk.Demo.gschema.xml
%{_datadir}/gtk-3.0/gtkbuilder.rng
%{_datadir}/gtk-3.0/valgrind/
%{_mandir}/man1/gtk3-demo.1*
%{_mandir}/man1/gtk3-demo-application.1*
%{_mandir}/man1/gtk3-icon-browser.1*
%{_mandir}/man1/gtk3-widget-factory.1*
%{_mandir}/man1/gtk-builder-tool.1*
%{_mandir}/man1/gtk-encode-symbolic-svg.1*
%{_mandir}/man1/gtk-query-settings.1*

%files devel-docs
%{_datadir}/gtk-doc

%files -n gtk-update-icon-cache
%license COPYING
%{_bindir}/gtk-update-icon-cache
%{abidir}/gtk-update-icon-cache-option.list
%{_mandir}/man1/gtk-update-icon-cache.1*

%files immodules
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-cedilla.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-am-et.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-cyrillic-translit.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-inuktitut.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-ipa.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-multipress.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-thai.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-ti-er.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-ti-et.so
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-viqr.so
%{abidir}/im-*.dump
%if 0%{?with_broadway}
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-broadway.so
%endif
%config(noreplace) %{_sysconfdir}/gtk-3.0/im-multipress.conf

%files immodule-xim
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-xim.so

%files tests
%{_libexecdir}/installed-tests/
%{_datadir}/installed-tests/

%files doc
%doc NEWS README.md


%changelog
* Wed Feb 12 2025 Zhao Hang <wb-zh951434@alibaba-inc.com> - 3.24.43-1
- Update to 3.24.43-1 from 3.24.38-1
- Update patch name for ci
- Migrated to SPDX license

* Tue May 23 2023 Funda Wang <fundawang@yeah.net> - 3.24.38-1
- New version 3.24.38

* Tue Apr 11 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> - 3.24.37-2
- Optimize spec file

* Sun Mar 5 2023 Funda Wang <fundawang@yeah.net> - 3.24.37-1
- New version 3.24.37

* Fri Dec 23 2022 Funda Wang <fundawang@yeah.net> - 3.24.36-1
- New version 3.24.36

* Fri Nov 25 2022 Funda Wang <fundawang@yeah.net> - 3.24.35-1
- New version 3.24.35

* Tue Nov 8 2022 Funda Wang <fundawang@yeah.net> - 3.24.34-1
- New version 3.24.34

* Thu Nov 03 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.24.33-3
- optimise spec file

* Mon Apr 11 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 3.24.33-2
- fix require failed for libXrandr

* Mon Apr 11 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 3.24.33-1
- init from upstream
- fix build failed with array-bound error
